/**
 */
package org.eclipse.gmf.codegen.gmfgen;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Gen Custom Generator Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#getGenerator <em>Generator</em>}</li>
 *   <li>{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#isFromCustomBridge <em>From Custom Bridge</em>}</li>
 *   <li>{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#getRootInput <em>Root Input</em>}</li>
 *   <li>{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#getInvocations <em>Invocations</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.gmf.codegen.gmfgen.GMFGenPackage#getGenCustomGeneratorExtension()
 * @model
 * @generated
 */
public interface GenCustomGeneratorExtension extends GenCustomTemplateInput {
	/**
	 * Returns the value of the '<em><b>Generator</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.gmf.codegen.gmfgen.GenEditorGenerator#getExtensions <em>Extensions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Generator</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Generator</em>' container reference.
	 * @see org.eclipse.gmf.codegen.gmfgen.GMFGenPackage#getGenCustomGeneratorExtension_Generator()
	 * @see org.eclipse.gmf.codegen.gmfgen.GenEditorGenerator#getExtensions
	 * @model opposite="extensions" resolveProxies="false" required="true" transient="false" changeable="false"
	 * @generated
	 */
	GenEditorGenerator getGenerator();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * User friendly name for this extension, used only in UI
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.gmf.codegen.gmfgen.GMFGenPackage#getGenCustomGeneratorExtension_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>From Custom Bridge</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Reconciler should try to preserve the contents if set to true
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>From Custom Bridge</em>' attribute.
	 * @see #setFromCustomBridge(boolean)
	 * @see org.eclipse.gmf.codegen.gmfgen.GMFGenPackage#getGenCustomGeneratorExtension_FromCustomBridge()
	 * @model default="false"
	 * @generated
	 */
	boolean isFromCustomBridge();

	/**
	 * Sets the value of the '{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#isFromCustomBridge <em>From Custom Bridge</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Custom Bridge</em>' attribute.
	 * @see #isFromCustomBridge()
	 * @generated
	 */
	void setFromCustomBridge(boolean value);

	/**
	 * Returns the value of the '<em><b>Root Input</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Root input element for custom template invocations. GenEditorGenerator single instance will be assumed if not set
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Root Input</em>' reference.
	 * @see #setRootInput(EObject)
	 * @see org.eclipse.gmf.codegen.gmfgen.GMFGenPackage#getGenCustomGeneratorExtension_RootInput()
	 * @model
	 * @generated
	 */
	EObject getRootInput();

	/**
	 * Sets the value of the '{@link org.eclipse.gmf.codegen.gmfgen.GenCustomGeneratorExtension#getRootInput <em>Root Input</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Root Input</em>' reference.
	 * @see #getRootInput()
	 * @generated
	 */
	void setRootInput(EObject value);

	/**
	 * Returns the value of the '<em><b>Invocations</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.gmf.codegen.gmfgen.GenTemplateInvocationBase}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.gmf.codegen.gmfgen.GenTemplateInvocationBase#getExtension <em>Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Invocations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Invocations</em>' containment reference list.
	 * @see org.eclipse.gmf.codegen.gmfgen.GMFGenPackage#getGenCustomGeneratorExtension_Invocations()
	 * @see org.eclipse.gmf.codegen.gmfgen.GenTemplateInvocationBase#getExtension
	 * @model opposite="extension" containment="true"
	 * @generated
	 */
	EList<GenTemplateInvocationBase> getInvocations();

} // GenCustomGeneratorExtension
